/*
 * Copyright (c) 2010-2016 OTClient <https://github.com/edubart/otclient>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#ifndef UICREATURE_H
#define UICREATURE_H

#include "declarations.h"
#include <framework/ui/uiwidget.h>
#include "creature.h"

class UICreature : public UIWidget
{
public:
    void drawSelf(Fw::DrawPane drawPane);

    void setCreature(const CreaturePtr& creature) { m_creature = creature; }
    void setFixedCreatureSize(bool fixed) { m_fixedCreatureSize = fixed; }
    void setOutfit(const Outfit& outfit);

    CreaturePtr getCreature() { return m_creature; }
    bool isFixedCreatureSize() { return m_fixedCreatureSize; }

protected:
    void onStyleApply(const std::string& styleName, const OTMLNodePtr& styleNode);

    CreaturePtr m_creature;
    stdext::boolean<false> m_fixedCreatureSize;
};

#endif
